//TextUeberlaufTest_304d.js / CS3
// 07.08.07 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Dieses Script versucht, Textrahmen mit berlauf aufzuspren

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

var curDoc = app.documents[0];

// drei Variablen vorbereiten
var tmpList = new Array();
var aCtr = 0;
var cCtr = 0;

// eine Schleife durch die Seiten
for (var i=0; i<curDoc.pages.length; i++) {
	var nFrames = curDoc.pages[i].textFrames.length;
	for (var j=0; j<nFrames; j++) {
		if (curDoc.pages[i].textFrames[j].overflows == true) {
			var pName = curDoc.pages[i].name;
			tmpList.push(pName);
			break;
		}
	}
	//... und durch eventuelle Gruppen
	var curGroups = curDoc.pages[i].groups;
	for (var j=0; j<curGroups.length; j++) {
		var allFrames = curGroups[j].allPageItems;
		for (var k=0; k<allFrames.length; k++) {
			var curFrame = allFrames[i];
			var curType = curFrame.constructor.name;
			if (curType == "TextFrame") {
				if (curFrame.overflows == true) {
					var pName = curDoc.pages[i].name;
					tmpList.push(pName);
					break;
				}
			}
		}
	}
}

// eine Schleife durch die Stories
var nStories = curDoc.stories.length;
for (var i=0; i<nStories; i++) {
	try {
		if (curDoc.stories[i].textFrames.item(-1).overflows) {
			try {
				var pName = curDoc.stories[i].textFrames.item(-1).parent.name;
			}
			catch (e) {
				aCtr++;
			}
		}
	}
	catch (e) {	
	}
	var allTables = curDoc.stories[i].tables;
	var nTables = allTables.length;
	if (nTables != 0) {
		for (var j=0; j<nTables; j++) {
			var allCells = allTables[j].cells;
			var nCells = allCells.length;
			for (var k=0; k<nCells; k++) {
				if (allCells[k].overflows) {
					cCtr++;
					break;
				}
			}
		}
	}
}

// mehrfache Eintrge reduzieren
var pageList = new Array();
for (var i=0; i<tmpList.length; i++) {
	var curItem = tmpList[i];
	var okay = true;
	for (var j=0; j<pageList.length; j++) {
		if (curItem == pageList[j]) {
			okay = false;
			break;
		}
	}
	if (okay) {
		pageList.push(curItem);
	}
}

// den Wert des Zhlers und den Inhalt der Liste prfen 
// und den entsprechenden Dialog anzeigen
if (aCtr == 0 && cCtr == 0) {
	if (pageList.length == 0) {
		alert ("Kein Textberlauf festgestellt.", "Alles okay");
	}
	else if (pageList.length == 1) {
		alert ("Textberlauf auf Seite " + pageList[0], "Achtung");
	}
	else {
		pageString = pageList.join(", ");
		alert ("Textberlauf auf den Seiten:\n\n" + pageString, "Achtung");
	}
}
else {
	if (pageList.length == 0) {
		alert ("Tabellen mit berlauf: = " + cCtr + "\nVerankerte Rahmen mit berlauf: " + aCtr + "\n(Seiten nicht bestimmt).", "Achtung");
	}
	else if (pageList.length == 1) {
		alert ("Textberlauf auf Seite " + pageList[0] + "\n\nUnd auch (Seiten nicht bestimmt):\nTabellen mit berlauf: " + cCtr + "\nVerankerte Rahmen mit berlauf: " + aCtr, "Achtung");
	}
	else {
		pageString = pageList.join(", ");
		alert ("Textberlauf auf den Seiten:\n" + pageString + "\n\nUnd auch (Seiten nicht bestimmt):\nTabellen mit berlauf: " + cCtr + "\nVerankerte Rahmen mit berlauf: " + aCtr, "Achtung");
	}
}